{
    // See https://go.microsoft.com/fwlink/?LinkId=733558
    // for the documentation about the tasks.json format
    "version": "2.0.0",
    "tasks": [
        {
            "label": "Build SoC",
            "type": "shell",
            "command": "cd scripts; ./build.sh",
            "group": "build",
            "presentation": {
                "echo": true,
                "reveal": "always",
                "focus": false,
                "panel": "shared",
                "showReuseMessage": true,
                "clear": false
            }
        },
        {
            "label": "Make Firmware",
            "type": "shell",
            "command": "cd scripts; ./make_firmware.sh",
            "group": "build",
            "presentation": {
                "echo": true,
                "reveal": "always",
                "focus": false,
                "panel": "shared",
                "showReuseMessage": true,
                "clear": false
            }
        },
        {
            "label": "Open Serial Boot Terminal",
            "type": "shell",
            "command": "cd scripts; ./open_term.sh boot",
            "group": "build",
            "presentation": {
                "echo": true,
                "reveal": "always",
                "focus": false,
                "panel": "dedicated",
                "showReuseMessage": true,
                "clear": false
            }
        },
        {
            "label": "Remove crt0.o",
            "type": "shell",
            "command": "source scripts/lbm_env_vars.sh; rm $LITEXDIR/soc/cores/cpu/vexriscv/crt0.o"
        },
        {
            "label": "Clear VCD File",
            "type": "shell",
            "command": "source scripts/lbm_env_vars.sh; rm $LITEXDIR/tools/build/sim/gateware/sim.vcd"
        },
        {
            "label": "Simulate SoC",
            "type": "shell",
            "command": "source scripts/lbm_env_vars.sh; cd $LITEXDIR/tools; module load gcc; module load verilator; module load libevent; py litex_sim.py --trace",
            "dependsOn": ["Clear VCD File", "Make Firmware", "Remove crt0.o"],
            "dependsOrder": "sequence",
        },
        {
            "label": "Program Board",
            "type": "shell",
            "command": "source scripts/lbm_env_vars.sh; cd scripts; vivado -source program_device.tcl -mode batch"
        },
        {
            "label": "Open Serial Terminal (no boot)",
            "type": "shell",
            "command": "cd scripts; ./open_term.sh noboot",
            "group": "build",
            "presentation": {
                "echo": true,
                "reveal": "always",
                "focus": false,
                "panel": "dedicated",
                "showReuseMessage": true,
                "clear": false
            }
        },
        {
            "label": "LBM Info",
            "type": "shell",
            "command": "cd litebusmonitor; clear; cat lbm_build_log.log"
        },
        {
            "label": "Record Readout (selByAck, blockEndMark)",
            "type": "shell",
            "command": "cd scripts; ./record_output.sh"
        },
        {
            "label": "Open LiteX Folder",
            "type": "shell",
            "command": "source scripts/lbm_env_vars.sh; thunar $LITEXDIR"
        },
        {
            "label": "[DEBUG] Set BIOS Normal",
            "type": "shell",
            "command": "source scripts/lbm_env_vars.sh; cp $LITEXDIR/soc/software/bios/NORMAL/main.c $LITEXDIR/soc/software/bios/main.c; cp $LITEXDIR/soc/software/libbase/NORMAL/isr.c $LITEXDIR/soc/software/libbase/isr.c"
        },
        {
            "label": "[DEBUG] Set BIOS Monitor-modified",
            "type": "shell",
            "command": "source scripts/lbm_env_vars.sh; cp $LITEXDIR/soc/software/bios/MONITOR/main.c $LITEXDIR/soc/software/bios/main.c; cp $LITEXDIR/soc/software/libbase/MONITOR/isr.c $LITEXDIR/soc/software/libbase/isr.c; cp $LITEXDIR/soc/software/libbase/MONITOR/isr.h $LITEXDIR/soc/software/libbase/isr.h"
        },
        {
            "label": "[TEST] Run unit tests",
            "type": "shell",
            "command": "./scripts/run_tests.sh"
        }

    ]
}